package test.rewolucja.resources.manager.factory;

import test.rewolucja.resources.logical.LogicalResource;
import test.rewolucja.resources.manager.implementation.ClusterResourceManager;
import test.rewolucja.resources.manager.implementation.ResourceManager;
import test.rewolucja.resources.manager.interfaces.ResourceManagerInterface;
import test.rewolucja.resources.physical.base.ComputingResource;
import test.rewolucja.scheduling.GridResourceDiscovery;

public class ResourceManagerFactory {

	public static ResourceManagerInterface createResourceManager(LogicalResource logicalResource){

		ComputingResource  parentResource = logicalResource.getResources().get(0).getParent();
		switch(parentResource.getType()){
			case COMPUTING_GRID: return new GridResourceDiscovery(logicalResource);
			case DATA_CENTER: return new ClusterResourceManager(logicalResource.getResources(), logicalResource.getChildren());
			case COMPUTING_NODE: return new ResourceManager(logicalResource.getResources(), logicalResource.getChildren());
		default:
			throw new IllegalArgumentException("ResourceType " + parentResource.getType() + " is not supported.");
		}
	}
}
